/*notsimple.c */
// Programmer- Kevin Korpi

#include <GL/glut.h>

GLsizei ww, wh;

// shapes color variables
int sa, sb, sc, ta, tb, tc, ra, rb, rc;
//initial color variables
int colorcount = 1, a = 1, b = 0, c = 0;

void square()
{
  //square
  glBegin(GL_POLYGON);
    glVertex2f(-2.0, 1.0);
    glVertex2f(-2.0, 2.0);
    glVertex2f(-1.0, 2.0);
    glVertex2f(-1.0, 1.0);
  glEnd();
}

void tri()
{
  // triangle
  glBegin(GL_POLYGON);
    glVertex2f(1.0, 1.0);
    glVertex2f(2.0, 1.0);
    glVertex2f(1.5, 2.0);
  glEnd();
}

void rom()
{

  glBegin(GL_POLYGON);
    glVertex2f(-1.5, -2.0);
    glVertex2f(-1.0, -1.0);
    glVertex2f(1.5, -1.0);
    glVertex2f(1.0, -2.0);
  glEnd();
}

void squarewire()
{
  //squarewireframe
  glBegin(GL_LINE_LOOP); 
    glVertex2f(-2.0, 1.0);
    glVertex2f(-2.0, 2.0);
    glVertex2f(-1.0, 2.0);
    glVertex2f(-1.0, 1.0);
  glEnd();
}

void triwire()
{
  // trianglewireframe
  glBegin(GL_LINE_LOOP);
    glVertex2f(1.0, 1.0);
    glVertex2f(2.0, 1.0);
    glVertex2f(1.5, 2.0);
  glEnd();
}

void romwire()
{
  glBegin(GL_LINE_LOOP);
    glVertex2f(-1.5, -2.0);
    glVertex2f(-1.0, -1.0);
    glVertex2f(1.5, -1.0);
    glVertex2f(1.0, -2.0);
  glEnd();
}

void display()

{

  glClear(GL_COLOR_BUFFER_BIT);

  glColor3f(sa, sb, sc);
  square();
  glColor3f(ta, tb, tc);
  tri();
  glColor3f(ra, rb, rc);
  rom();

  // shape names
  glColor3f(0.0, 0.0, 0.0);
  glRasterPos2d(-2.0, 0.5);
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'S');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'Q');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'U');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'A');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'R');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'E');
  glRasterPos2d(1.0, 0.5);
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'T');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'R');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'I');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'A');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'N');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'G');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'L');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'E');
  glRasterPos2d(-1.0, -.75);
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'R');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'H');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'O');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'M');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'B');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'U');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'S');
  //  glFlush();
  glutSwapBuffers();

}

// wireframes
void displaywire()
{

  glClear(GL_COLOR_BUFFER_BIT);
  glLineWidth(3.0);
  glLineStipple(3, 0xcccc);

  glColor3f(sa, sb, sc);
  squarewire();
  glColor3f(ta, tb, tc);
  triwire();
  glColor3f(ra, rb, rc);
  romwire();

  // shapes names
  glColor3f(0.0, 0.0, 0.0);
  glRasterPos2d(-2.0, 0.5);
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'S');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'Q');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'U');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'A');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'R');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'E');
  glRasterPos2d(1.0, 0.5);
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'T');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'R');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'I');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'A');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'N');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'G');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'L');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'E');
  glRasterPos2d(-1.0, -.75);
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'R');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'H');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'O');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'M');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'B');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'U');
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_10, 'S');
  glutSwapBuffers();
}

int count = 0;
void mode()
{
  if (count % 2  == 0) {
    displaywire();
  }
  else {
    display();
  }
  count++;

}

void currentcolor()
{
  colorcount++;
  if (colorcount == 1) {
    a = 1, b = 0, c = 0;
  }
  else if (colorcount == 2) {
    a = 0, b = 0, c = 1;
  }
  else {
    a = 0, b = 1, c = 0;
    colorcount = 0;
  }
}

void init()
{

  // white background
  glClearColor(1.0, 1.0, 1.0, 1.0);
  //  color of shape
  glColor3f(0.0, 0.0, 0.0);
  glEnable(GL_LINE_STIPPLE);
  glLineWidth(3.0);
  glLineStipple(3, 0xcccc);

}


GLsizei w, h;
void myreshape(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (w <= h) {
    gluOrtho2D (-2.0, 2.0, -2.0 * (GLfloat) h /	
		(GLfloat) w, 2.0 * (GLfloat) h / (GLfloat) w);
  }
  else {
    gluOrtho2D (-2.0 * (GLfloat) w / (GLfloat) h, 
		2.0 * (GLfloat) w/(GLfloat) h, -2.0, 2.0);
  }
  glMatrixMode(GL_MODELVIEW);

  glViewport(0, 0, w, h);
  glLoadIdentity();
  if (count % 2 != 0) {
    glutDisplayFunc(displaywire);
  }
  else {
    glutDisplayFunc(display);
  }

  ww = w;
  wh = h;
// doh duh! damn reshape function finally works
}

void mykey(int key)
{
  //  if (key == 'Q' || key == 'q') exit(0);
  if (key == 'M' || key == 'm') mode();
  if (key == 'S' || key == 's') {
    sa = a, sb = b, sc = c;
    glColor3f(sa, sb, sc);
    if (count % 2 == 0) {
      square();
    }
    else {
      squarewire();
    }
    glutSwapBuffers();
  }
  if (key == 'T' || key == 't') {
    ta = a, tb = b, tc = c;
    glColor3f(ta, tb, tc);
    if (count %2 == 0) {
      tri();
    }
    else {
      triwire();
    }
    glutSwapBuffers();
  }
  if (key == 'C' || key == 'c') currentcolor();
  if (key == 'R' || key == 'r') {
    ra = a, rb = b, rc = c;
    glColor3f(ra, rb, rc);
    if (count % 2 == 0) {
      rom();
    }
    else {
      romwire();
    }
    glutSwapBuffers();
  }
}

int main(int argc, char** argv)
{

  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(100, 100);
  glutInitWindowPosition(100, 0);
  glutCreateWindow("simple");
  glutDisplayFunc(display);
  init();
  glutReshapeFunc(myreshape);
  glutKeyboardFunc(mykey);
  glutMainLoop();

}
